//SPDX-License-Identifier: UNLICENSED

pragma solidity >=0.6;

contract grouptrip{
  address payable private operator;
  uint public startTime;
  uint public minPax;
  uint public maxPax;
  uint public fee;
  uint public people;
  
  constructor (uint _minPax, uint _maxPax, uint _fee) {
    operator = payable(msg.sender); 
    startTime = 0;
    people = 0;
    minPax = _minPax;
    maxPax = _maxPax;
    fee = _fee;
  }
  
  function sign_up(uint newPeople) payable public{
    require(msg.value >= newPeople * fee, "You must pay for each passenger");
    require(people + newPeople <= maxPax, "Your trip is full!");  
    people = people + newPeople;
    if (people == 0){
       startTime = block.timestamp + 40; 
    }
  }

  function start_trip() public returns(bool){
    require(payable(msg.sender)==operator, "You are not the tour operator");  
    require(block.timestamp >= startTime, "Trip not ready for departure");  
    if (fee * minPax <= address(this).balance){
      operator.transfer(address(this).balance);
						people = 0;
      return true;
    }else{
       	startTime = block.timestamp + 40; 
    	return false;
    }
  }
  
  function missing_balance() view public returns(uint){
    if(minPax * fee > address(this).balance) {
      return minPax * fee - address(this).balance;
    }else{
      return 0;
    }
  }
  
  function chip_in() payable public{
    require(people > 0, "There are no passengers for this trip");  
    require(msg.value >= missing_balance(), "You have not paid enough");
  }
 
}
